# Eesyvpn

Outil de gestion de VPN basé sur OpenVPN. 


## Usage

  eesyvpn {create|recreate|view|renew|revoke|makeconf|makezipconf|makeovpnconf|makecert|namebyid} certificate_name [options]
  eesyvpn {list|update-crl} [options]
  eesyvpn initialize [you.server.fqdn] [-f config-file]

## Options

  * -e OS (windows|linux) - Indique l'OS du client (Windows si omis).
  * -f fichier de configuration - Indique le fichier de configuration du VPN sur lequel opérer (/etc/eesyvpn/eesyvpn.conf si omis).

##  Ajouter une instance serveur OpenVPN

  - Créer un fichier de configuration dédiée à cette instance. Prendre comme modèle ''/etc/eesyvpn/eesyvpn.conf'' et ajuster les valeurs des variables suivantes qui y sont définies:
      * VPN_NAME: Nom de l'instance VPN qui sera créée
      * VPN_CLIENT_NAME: Nom du VPN qui sera affichée aux utilisateurs
      * VPN_PORT: le port sur lequel l'instance VPN va écouter
  - Les autres variables présentes dans le fichier de configuration sont dérivées de ces 3 variables.
  - Créer l'instance VPN avec la commande suivante : eesyvpn initialize <FQDN> -f <FICHIER_DE_CONFIGURATION>
  - Répondre aux questions permettant de construire l'autorité de certification. Il faudra notamment fournir un nom pour le CN du certificat de l'autorité de certification et un mot de passe pour protéger sa clé privée. Tous les fichiers de configuration qui ont trait à l'instance VPN créée et nécessaire à Eesyvpn seront dans ''/etc/eesyvpn/<VPN_NAME>''
  - Ajuster la configuration de l'instance VPN en éditant le fichier ''/etc/openvpn/server/<VPN_NAME>.conf''
  - Ajuster le template servant à la création des fichiers de configuration des clients en éditant le fichier ''/etc/eesyvpn/VPN_NAME/openvpn/client.ovpn.tpl''
  - Ajouter la conf logrotate pour les logs du VPN

## Ajouter un client OpenVPN

eesyvpn create <NOM_DU_CLIENT> -f <FICHIER_DE_CONFIGURATION> -e <ENV>

L'argument du drpeau -f sert à désigner le fichier de configuration du VPN sur lequel on veut opérer. Attention, si il est omis c'est le fichier /etc/eesyvpn/eesyvpn.conf qui est utilisé. La configuration sera générée dans ''/etc/eesyvpn/<VPN_NAME>/openvpn/clients'' et zippée.
 
## Révoquer un certificat

Par défaut le paramètre ''crl-verify'' est commenté mais il n'y a pas besoin de l'éditer manuellement. Il faut utiliser la commande "eesyvpn revoke certificate_name [options]". Le script se charge d'activer la fonctionnalité ''crl-verify''.


## Publish a new release

- Make all changes needs in the ''master'' branch with explicit commits messages that will be used to compose the Debian changelog entries
- add the version tag: ''git tag 1.0''
- push changes to remote repository: ''git push && git push --tags''
- For each Debian supported release:
  - switch to dedicated branch: `git checkout bookworm`
  - update the branch: `git pull origin bookworm`
  - retrieve changes from the `master` branch: `git cherry-pick [commit ID]`
  - add the version tag: `git tag 1.6.0-ee120`
  - push changes to remote repository: `git push origin bookworm && git push --tags`

## Locally build (using Docker)

You also could manually build a specific release using the following command:

```bash
docker run --rm -it -v "$(pwd):/src" -w /src -e DEBFULLNAME -e DEBEMAIL -e GPG_KEY debian:12 ./build.sh --install-build-deps
```

Release builded files will be store in the `dist` directory.

### Packages signing

By default, built packages are not signed but you could provide information to allow their signature :

- be sure to define `DEBFULLNAME` and `DEBEMAIL` environment variables
- run the `docker run` command in a context where the `GPG_KEY` environment variable is set as follow :

```bash
GPG_KEY=$( gpg --armor --export-secret-key $DEBEMAIL|base64|tr -d '\n' )
```

**Important :** This solution only work with GPG key **without password** defined. If you have to use a GPG key with a password, you have to remove it before by running the following command :

```
gpg --edit-key $DEBEMAIL
> passwd
> quit
```

Be sure to restore your password after building the Debian packages.

**Note :** the `build.sh` script accept a `--gpg-key` parameter, but it will only works if the GPG key is available in the running context, so probably not in a docker container or not if script is run with `sudo`.

